# coding: utf-8

# flake8: noqa

"""
    avis

    VUE Autonomous Visual Inspection System (AVIS)

    The version of the OpenAPI document: 0.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "0.7.0"

# import apis into sdk package
from avis_client.api.api_keys_api import ApiKeysApi
from avis_client.api.configuration_api import ConfigurationApi
from avis_client.api.image_api import ImageApi
from avis_client.api.image_attribute_api import ImageAttributeApi
from avis_client.api.image_attribute_category_api import ImageAttributeCategoryApi
from avis_client.api.inspection_api import InspectionApi
from avis_client.api.membership_api import MembershipApi
from avis_client.api.metadata_api import MetadataApi
from avis_client.api.metadata_schema_api import MetadataSchemaApi
from avis_client.api.ml_api import MlApi
from avis_client.api.product_api import ProductApi
from avis_client.api.product_category_api import ProductCategoryApi
from avis_client.api.quality_criteria_api import QualityCriteriaApi
from avis_client.api.result_api import ResultApi
from avis_client.api.statistics_api import StatisticsApi
from avis_client.api.teams_api import TeamsApi
from avis_client.api.user_api import UserApi

# import ApiClient
from avis_client.api_response import ApiResponse
from avis_client.api_client import ApiClient
from avis_client.configuration import Configuration
from avis_client.exceptions import OpenApiException
from avis_client.exceptions import ApiTypeError
from avis_client.exceptions import ApiValueError
from avis_client.exceptions import ApiKeyError
from avis_client.exceptions import ApiAttributeError
from avis_client.exceptions import ApiException

# import models into sdk package
from avis_client.models.azure_ml_inference_request import AzureMLInferenceRequest
from avis_client.models.blank_enum import BlankEnum
from avis_client.models.configuration_type import ConfigurationType
from avis_client.models.configuration_type_request import ConfigurationTypeRequest
from avis_client.models.custom_user import CustomUser
from avis_client.models.custom_user_request import CustomUserRequest
from avis_client.models.email_address import EmailAddress
from avis_client.models.format_enum import FormatEnum
from avis_client.models.image import Image
from avis_client.models.image_attribute import ImageAttribute
from avis_client.models.image_attribute_category import ImageAttributeCategory
from avis_client.models.image_attribute_category_request import ImageAttributeCategoryRequest
from avis_client.models.image_attribute_request import ImageAttributeRequest
from avis_client.models.image_request import ImageRequest
from avis_client.models.inspection import Inspection
from avis_client.models.inspection_images_statistics import InspectionImagesStatistics
from avis_client.models.inspection_images_statistics_request import InspectionImagesStatisticsRequest
from avis_client.models.inspection_request import InspectionRequest
from avis_client.models.inspection_statistics import InspectionStatistics
from avis_client.models.inspection_statistics_request import InspectionStatisticsRequest
from avis_client.models.inspection_status import InspectionStatus
from avis_client.models.inspection_status_enum import InspectionStatusEnum
from avis_client.models.inspection_validation_status import InspectionValidationStatus
from avis_client.models.ml_model import MLModel
from avis_client.models.ml_model_request import MLModelRequest
from avis_client.models.ml_model_type import MLModelType
from avis_client.models.ml_model_type_request import MLModelTypeRequest
from avis_client.models.membership import Membership
from avis_client.models.membership_request import MembershipRequest
from avis_client.models.metadata import Metadata
from avis_client.models.metadata_request import MetadataRequest
from avis_client.models.metadata_schema import MetadataSchema
from avis_client.models.metadata_schema_request import MetadataSchemaRequest
from avis_client.models.paginated_configuration_type_list import PaginatedConfigurationTypeList
from avis_client.models.paginated_image_attribute_category_list import PaginatedImageAttributeCategoryList
from avis_client.models.paginated_image_attribute_list import PaginatedImageAttributeList
from avis_client.models.paginated_image_list import PaginatedImageList
from avis_client.models.paginated_inspection_images_statistics_list import PaginatedInspectionImagesStatisticsList
from avis_client.models.paginated_inspection_list import PaginatedInspectionList
from avis_client.models.paginated_inspection_statistics_list import PaginatedInspectionStatisticsList
from avis_client.models.paginated_inspection_status_list import PaginatedInspectionStatusList
from avis_client.models.paginated_inspection_validation_status_list import PaginatedInspectionValidationStatusList
from avis_client.models.paginated_ml_model_list import PaginatedMLModelList
from avis_client.models.paginated_ml_model_type_list import PaginatedMLModelTypeList
from avis_client.models.paginated_membership_list import PaginatedMembershipList
from avis_client.models.paginated_metadata_list import PaginatedMetadataList
from avis_client.models.paginated_metadata_schema_list import PaginatedMetadataSchemaList
from avis_client.models.paginated_product_category_list import PaginatedProductCategoryList
from avis_client.models.paginated_product_list import PaginatedProductList
from avis_client.models.paginated_quality_criteria_list import PaginatedQualityCriteriaList
from avis_client.models.paginated_quality_criteria_result_list import PaginatedQualityCriteriaResultList
from avis_client.models.paginated_result_list import PaginatedResultList
from avis_client.models.paginated_team_list import PaginatedTeamList
from avis_client.models.patched_configuration_type_request import PatchedConfigurationTypeRequest
from avis_client.models.patched_image_attribute_category_request import PatchedImageAttributeCategoryRequest
from avis_client.models.patched_image_attribute_request import PatchedImageAttributeRequest
from avis_client.models.patched_image_request import PatchedImageRequest
from avis_client.models.patched_inspection_request import PatchedInspectionRequest
from avis_client.models.patched_ml_model_request import PatchedMLModelRequest
from avis_client.models.patched_ml_model_type_request import PatchedMLModelTypeRequest
from avis_client.models.patched_metadata_request import PatchedMetadataRequest
from avis_client.models.patched_metadata_schema_request import PatchedMetadataSchemaRequest
from avis_client.models.patched_product_category_request import PatchedProductCategoryRequest
from avis_client.models.patched_product_request import PatchedProductRequest
from avis_client.models.patched_quality_criteria_request import PatchedQualityCriteriaRequest
from avis_client.models.patched_result_request import PatchedResultRequest
from avis_client.models.patched_result_request_status import PatchedResultRequestStatus
from avis_client.models.product import Product
from avis_client.models.product_category import ProductCategory
from avis_client.models.product_category_request import ProductCategoryRequest
from avis_client.models.product_request import ProductRequest
from avis_client.models.quality_criteria import QualityCriteria
from avis_client.models.quality_criteria_request import QualityCriteriaRequest
from avis_client.models.quality_criteria_result import QualityCriteriaResult
from avis_client.models.quality_enum import QualityEnum
from avis_client.models.result import Result
from avis_client.models.result_request import ResultRequest
from avis_client.models.status_enum import StatusEnum
from avis_client.models.team import Team
from avis_client.models.team_request import TeamRequest
from avis_client.models.user_api_key_create import UserAPIKeyCreate
from avis_client.models.user_api_key_create_request import UserAPIKeyCreateRequest
from avis_client.models.validation_status_enum import ValidationStatusEnum
